<!--
	Markdown
	
	Copyright 2018 IS2T. All rights reserved.
	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
-->

# ESP32-WROVER BSP

This project contains the BSP sources of MicroEJ Reference Implementation for the ESP32-WROVER.
The BSP project is based on Espressif IoT Development Framework (ESP IDF).


# Build & Flash

You can find more information about the build and the flash process [here](https://gitlab.cross/Imported/espressif/esp-idf/blob/master/README.md) _(esp-idf/README.md)_.

**Warning:** Before building and linking the BSP project with your MicroEJ Java application, you need modifying the script file [esp32.common.ld](https://gitlab.cross/Imported/espressif/esp-idf/blob/master/components/esp32/ld/esp32.common.ld) _(esp-idf/components/esp32/ld/esp32.common.ld)_ by adding some MicroEJ runtime sections in the `dram0.bss` and the `flash.rodata` memory region.

The sections to add in `dram0.bss` memory region are `ICETEA_HEAP`, `_java_heap` and `_java_immortals`:

  .dram0.bss (NOLOAD) :<br/>
  {<br/>
    . = ALIGN (8);<br/>
    \_bss_start = ABSOLUTE(.);<br/>
    \*(.dynsbss)<br/>
    \*(.sbss)<br/>
    \*(.sbss.\*)<br/>
    \*(.gnu.linkonce.sb.\*)<br/>
    \*(.scommon)<br/>
    \*(.sbss2)<br/>
    \*(.sbss2.\*)<br/>
    \*(.gnu.linkonce.sb2.\*)<br/>
    \*(.dynbss)<br/>
    \*(.bss)<br/>
    \*(.bss.\*)<br/>
    \*(.share.mem)<br/>
    \*(.gnu.linkonce.b.\*)<br/>
    `*(ICETEA_HEAP)`<br/>
    `*(_java_heap)`<br/>
    `*(_java_immortals)`<br/>
    \*(COMMON)<br/>
    . = ALIGN (8);<br/>
    \_bss_end = ABSOLUTE(.);<br/>
    \_heap_start = ABSOLUTE(.);<br/>
  } >dram0\_0_seg<br/>

The sections to add in the `flash.rodata` memory region are `.text.soar` and `.text.soar.*`:

  .flash.rodata :<br/>
  {
    \_rodata_start = ABSOLUTE(.);<br/>
    \*(.rodata)<br/>
    \*(.rodata.\*)<br/>
    `*(.text.soar)`<br/>
    `*(.text.soar.*)`<br/>
    \*(.irom1.text) /\* catch stray ICACHE\_RODATA_ATTR \*/<br/>
    \*(.gnu.linkonce.r.\*)<br/>
    \*(.rodata1)<br/>
    \_\_XT\_EXCEPTION\_TABLE\_ = ABSOLUTE(.);<br/>
    \*(.xt\_except_table)<br/>
    \*(.gcc\_except_table)<br/>
    \*(.gnu.linkonce.e.\*)<br/>
    \*(.gnu.version_r)<br/>
    \*(.eh_frame)<br/>
    . = (. + 3) & ~ 3;<br/>
    /\*  C++ constructor and destructor tables, properly ordered:  \*/<br/>
    \_\_init\_array\_start = ABSOLUTE(.);<br/>
    KEEP (\*crtbegin.o(.ctors))<br/>
    KEEP (\*(EXCLUDE\_FILE (\*crtend.o) .ctors))<br/>
    KEEP (\*(SORT(.ctors.\*)))<br/>
    KEEP (\*(.ctors))<br/>
    \_\_init\_array_end = ABSOLUTE(.);<br/>
    KEEP (\*crtbegin.o(.dtors))<br/>
    KEEP (\*(EXCLUDE_FILE (\*crtend.o) .dtors))<br/>
    KEEP (\*(SORT(.dtors.\*)))<br/>
    KEEP (\*(.dtors))<br/>
    /\*  C++ exception handlers table:  \*/<br/>
    \_\_XT\_EXCEPTION\_DESCS_ = ABSOLUTE(.);<br/>
    \*(.xt\_except_desc)<br/>
    \*(.gnu.linkonce.h.\*)<br/>
    \_\_XT\_EXCEPTION\_DESCS_END\_\_ = ABSOLUTE(.);<br/>
    \*(.xt\_except\_desc_end)<br/>
    \*(.dynamic)<br/>
    \*(.gnu.version_d)<br/>
    \_rodata\_end = ABSOLUTE(.);<br/>
    /\* Literals are also RO data. \*/<br/>
    \_lit4\_start = ABSOLUTE(.);<br/>
    \*(\*.lit4)<br/>
    \*(.lit4.\*)<br/>
    \*(.gnu.linkonce.lit4.\*)<br/>
    \_lit4\_end = ABSOLUTE(.);<br/>
    . = ALIGN(4);<br/>
  } >drom0\_0_seg<br/>
