/*
 * C
 *
 * Copyright 2017-2018 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef LLRCOMMAND_BLUETOOTH_IMPL_H
#define LLRCOMMAND_BLUETOOTH_IMPL_H

#include <stdint.h>
#include "intern/LLRCOMMAND_BLUETOOTH_impl.h"


#ifdef __cplusplus
	extern "C" {
#endif

#define LLRCOMMAND_BLUETOOTH_IMPL_NO_ERROR		(0)
#define LLRCOMMAND_BLUETOOTH_IMPL_IO_ERROR		(-1)
#define LLRCOMMAND_BLUETOOTH_IMPL_MEM_ERROR		(-2)

#define LLRCOMMAND_BLUETOOTH_IMPL_NATIVE_CODE_BLOCKED_WITHOUT_RESULT		(-22)

/** @brief Status OK */
#define LLRCOMMAND_BLUETOOTH_STATUS_OK               (0x00)
/** @brief Status Undefined ERROR */
#define LLRCOMMAND_BLUETOOTH_STATUS_UNDEFINED_ERROR  (0x01)

int32_t LLRCOMMAND_BLUETOOTH_IMPL_init(uint8_t retry);
int32_t LLRCOMMAND_BLUETOOTH_IMPL_deinit(uint8_t retry);
int32_t LLRCOMMAND_BLUETOOTH_IMPL_scanStart(uint8_t retry);
int32_t LLRCOMMAND_BLUETOOTH_IMPL_scanStop(uint8_t retry);
int32_t LLRCOMMAND_BLUETOOTH_IMPL_connect(int32_t deviceAddrType, int8_t* deviceAddr, int32_t deviceAddrLength, uint8_t retry);
int32_t LLRCOMMAND_BLUETOOTH_IMPL_write(int32_t handle, int8_t* data, int32_t offset, int32_t length, uint8_t retry);
int32_t LLRCOMMAND_BLUETOOTH_IMPL_read(int32_t handle, uint8_t retry);
int32_t LLRCOMMAND_BLUETOOTH_IMPL_notifyEvent(int8_t* data, int32_t length, uint8_t retry);
int32_t LLRCOMMAND_BLUETOOTH_IMPL_disconnect(uint8_t retry);

#ifdef __cplusplus
	}
#endif

#endif // LLRCOMMAND_BLUETOOTH_IMPL_H
