/*
 * C
 *
 * Copyright 2018 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef LLRCOMMAND_BLUETOOTH_INTERNALS_H_
#define LLRCOMMAND_BLUETOOTH_INTERNALS_H_

#include "esp_bt.h"
#include "esp_gap_ble_api.h"
#include "esp_gattc_api.h"
#include "esp_gatt_defs.h"
#include "esp_bt_main.h"
#include "esp_gatt_common_api.h"

// uncomment to enable debug trace
//#define LLRCOMMAND_BLUETOOTH_DEBUG

#define LLRCOMMAND_BLUETOOTH_NOTIFICATION_BUFFER_SIZE	128

#define LLRCOMMAND_BLUETOOTH_GATT_WRITE_SIZE		20
#define LLRCOMMAND_BLUETOOTH_GATT_READ_SIZE			20
#define LLRCOMMAND_BLUETOOTH_NOTIFICATION_MAX_SIZE	100

#define LLRCOMMAND_BLUETOOTH_SCAN_RESULT_OPCODE		0x04
#define LLRCOMMAND_BLUETOOTH_CONNECT_RESULT_OPCODE	0x05
#define LLRCOMMAND_BLUETOOTH_OP_COMPLETE_OPCODE		0x10

#define LLRCOMMAND_BLUETOOTH_READ_OPCODE			0x02
#define LLRCOMMAND_BLUETOOTH_WRITE_OPCODE			0x03
#define LLRCOMMAND_BLUETOOTH_NOTIFICATION_OPCODE	0x06

#define LLRCOMMAND_BLUETOOTH_STATUS_NOT_CONNECTED   0x00
#define LLRCOMMAND_BLUETOOTH_STATUS_CONNECTED       0x01

#define LLRCOMMAND_BLUETOOTH_SCAN_RESULT_SIZE		0x0B
#define LLRCOMMAND_BLUETOOTH_CONNECT_RESULT_SIZE	0x01
#define LLRCOMMAND_BLUETOOTH_OP_COMPLETE_SIZE		0x0E

typedef struct {
	bool is_connected;
	bool is_scanning;
} LLRCOMMAND_BLUETOOTH_state;

LLRCOMMAND_BLUETOOTH_state llrcommand_bluetooth_current_state;

/* ESP32 callbacks */


esp_gatt_status_t LLRCOMMAND_BLUETOOTH_gatt_connection_up(esp_ble_gattc_cb_param_t *p_conn_status);

#endif /* LLRCOMMAND_BLUETOOTH_INTERNALS_H_ */
