<!--
	Copyright 2018 IS2T. All rights reserved.
	For demonstration purpose only
	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
-->

# Build MicroEJ Platform Reference Implementation for ESP32-WROVER

## Delivery 

Folders listing:
 * `platformArchitecture`: contains MicroEJ Platform Architecture and Platform Architecture Extensions.
 * `platformSource`: contains a zip file with the MicroEJ Platform Reference Implementation sources.

## Prerequisites

 * Java7 or higher
 * MicroEJ SDK 4.1 or later
 * ESP32 SDK 3.0-rc1

## Import MicroEJ Platform Architecture (Platform Architecture and MicroEJ Architecture Extensions)

 * Open MicroEJ SDK. 
 * Click on `Window > Preferences > MicroEJ`. If no MicroEJ SDK repository is set, select a file system directory to store the MicroEJ SDK repository with the `Browse` button. 
 * Go to `MicroEJ > Architectures` and click on `Import...`.
 * Select `Select directory` and set the path of the `platformArchitecture` folder of the delivery. Select all elements and check `I agree and accept...` checkbox. 
 * Click on the `Finish` button. The MicroEJ platforms architectures are now imported in the MicroEJ SDK repository. The menu `MicroEJ > Architectures` has been updated.

## Import MicroEJ Platform Reference Implementation Sources

 * Open MicroEJ SDK. 
 * Click on `File > Import... > MicroEJ > Examples and Platform Reference Implementations`
 * Click on `Next`
 * Check the radio button `Select file`
 * Select the MicroEJ Platform Reference Implementation sources zip file with the `Browse` button. 
 * New items appear in the list. Select all items and click on `Finish`. 

The MicroEJ Platform Reference Implementation sources are now imported in the MicroEJ SDK repository.

## (Optional) Install additional plugins

  * Open MicroEJ SDK.
  * Click on `Help > Install New Software...`
  * Make sure the box `Group items by category` is unchecked
  * Click the `Add...` and then select `Archive...`
  * Select the desired plugin in the `plugins` folder of the MicroEJ Platform Reference Implementation
  * New items appear in the software list, select the plugins you want to install and finish the operation.
  
The MicroEJ SDK will have to restart to finalize the installation.

## Build MicroEJ Platform Reference Implementation 

 * Click on `File > New > MicroEJ > Platform`.
 * Select your MicroEJ Platform Architecture with `Browse` button. Once selected, some platform reference implementation appear in a list.
 * Select `Platform > ESP32-WROVER > SingleApp FreeRTOS [HDAHT-1.3.0]` platform reference implementation.
 * Click on `Next`. 
 * Enter some platform reference implementation meta data 
 * Click on `Finish` button. Some projects have been added in your MicroEJ SDK workspace.
 * A new document has been opened, follow the new instructions.
